Loading...
Searching...
No Matches
pcl::VoxelGridCovariance< PointT >::Leaf Struct Reference

Simple structure to hold a centroid, covarince and the number of points in a leaf. More...

`#include <pcl/filters/voxel_grid_covariance.h>`

## Public Member Functions

| Leaf ()
| Constructor.
Eigen::Matrix3d | getCov () const
| Get the voxel covariance.
Eigen::Matrix3d | getInverseCov () const
| Get the inverse of the voxel covariance.
Eigen::Vector3d | getMean () const
| Get the voxel centroid.
Eigen::Matrix3d | getEvecs () const
| Get the eigen vectors of the voxel covariance.
Eigen::Vector3d | getEvals () const
| Get the eigen values of the voxel covariance.
int | getPointCount () const
| Get the number of points contained by this voxel.

## Public Attributes

int | nr_points {0}
| Number of points contained by voxel.
Eigen::Vector3d | mean_
| 3D voxel centroid
Eigen::VectorXf | centroid
| Nd voxel centroid.
Eigen::Matrix3d | cov_
| Voxel covariance matrix.
Eigen::Matrix3d | icov_
| Inverse of voxel covariance matrix.
Eigen::Matrix3d | evecs_
| Eigen vectors of voxel covariance matrix.
Eigen::Vector3d | evals_
| Eigen values of voxel covariance matrix.

## Detailed Description

template<typename PointT>
struct pcl::VoxelGridCovariance< PointT >::Leaf

Simple structure to hold a centroid, covarince and the number of points in a leaf.

Inverse covariance, eigen vectors and engen values are precomputed.

Definition at line 91 of file voxel_grid_covariance.h.

## Constructor & Destructor Documentation

## Leaf()

template<typename PointT>

pcl::VoxelGridCovariance< PointT >::Leaf::Leaf | ( |  | ) |

inline

Constructor.

Sets nr_points, cov_, icov_, mean_ and evals_ to 0 and evecs_ to the identity matrix

Definition at line 96 of file voxel_grid_covariance.h.

References cov_, evals_, evecs_, icov_, and mean_.

## Member Function Documentation

## getCov()

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::getCov | ( |  | ) | const

inline

Get the voxel covariance.

Returns
  covariance matrix

Definition at line 109 of file voxel_grid_covariance.h.

References cov_.

## getEvals()

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::getEvals | ( |  | ) | const

inline

Get the eigen values of the voxel covariance.

Note
  Order corresponds with getEvecs

Returns
  vector of eigen values

Definition at line 147 of file voxel_grid_covariance.h.

References evals_.

## getEvecs()

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::getEvecs | ( |  | ) | const

inline

Get the eigen vectors of the voxel covariance.

Note
  Order corresponds with getEvals

Returns
  matrix whose columns contain eigen vectors

Definition at line 137 of file voxel_grid_covariance.h.

References evecs_.

## getInverseCov()

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::getInverseCov | ( |  | ) | const

inline

Get the inverse of the voxel covariance.

Returns
  inverse covariance matrix

Definition at line 118 of file voxel_grid_covariance.h.

References icov_.

## getMean()

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::getMean | ( |  | ) | const

inline

Get the voxel centroid.

Returns
  centroid

Definition at line 127 of file voxel_grid_covariance.h.

References mean_.

## getPointCount()

template<typename PointT>

int pcl::VoxelGridCovariance< PointT >::Leaf::getPointCount | ( |  | ) | const

inline

Get the number of points contained by this voxel.

Returns
  number of points

Definition at line 156 of file voxel_grid_covariance.h.

References nr_points.

## Member Data Documentation

## centroid

template<typename PointT>

Eigen::VectorXf pcl::VoxelGridCovariance< PointT >::Leaf::centroid

Nd voxel centroid.

Note
  Differs from mean_ when color data is used

Definition at line 170 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter().

## cov_

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::cov_

Voxel covariance matrix.

Definition at line 173 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), getCov(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), and Leaf().

## evals_

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::evals_

Eigen values of voxel covariance matrix.

Definition at line 182 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), getEvals(), and Leaf().

## evecs_

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::evecs_

Eigen vectors of voxel covariance matrix.

Definition at line 179 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), getEvecs(), and Leaf().

## icov_

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::icov_

Inverse of voxel covariance matrix.

Definition at line 176 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), getInverseCov(), and Leaf().

## mean_

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::mean_

3D voxel centroid

Definition at line 165 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), getMean(), and Leaf().

## nr_points

template<typename PointT>

int pcl::VoxelGridCovariance< PointT >::Leaf::nr_points {0}

Number of points contained by voxel.

Definition at line 162 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), and getPointCount().

The documentation for this struct was generated from the following file:

- pcl/filters/voxel_grid_covariance.h